Index: applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/gui/FactoryDialog.java
===================================================================
--- applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/gui/FactoryDialog.java	(revision 15203)
+++ applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/gui/FactoryDialog.java	(revision 15461)
@@ -37,12 +37,4 @@
         implements SelectionChangedListener, StatusListener {
 
-    private static FactoryDialog singleton = null;
-    public static FactoryDialog getInstance() {
-        if (singleton == null)
-            singleton = new FactoryDialog();
-        return singleton;
-    }
-
-
     HouseListModel  houseModel  = new HouseListModel();
     StreetListModel streetModel = new StreetListModel();
@@ -65,5 +57,5 @@
         add(mainPanel);
 
-        // Register to all listeners
+        // Register to all messages
         CzechAddressPlugin.addStatusListener(this);
 
@@ -94,5 +86,4 @@
             keepOddityCheckBox.setEnabled(true);
             return;
-
         }
         
@@ -115,5 +106,5 @@
 
     public boolean existsAvailableHouse() {
-        Reasoner r = CzechAddressPlugin.getReasoner();
+        Reasoner r = CzechAddressPlugin.reasoner;
 
         int i = houseList.getSelectedIndex();
@@ -136,5 +127,4 @@
     public void selectNextUnmatchedHouse() {
 
-        Reasoner r = CzechAddressPlugin.getReasoner();
         int index = houseList.getSelectedIndex();
 
@@ -142,5 +132,5 @@
         Object current;
         while ( (current = houseModel.getElementAt(index)) != null
-                && r.translate((House) current) != null)
+              && CzechAddressPlugin.reasoner.translate((House) current) != null)
             index++;
 
@@ -326,5 +316,5 @@
     private void houseListClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_houseListClicked
         if (evt.getClickCount() == 2 && evt.getButton() == MouseEvent.BUTTON1) {
-            Reasoner r = CzechAddressPlugin.getReasoner();
+            Reasoner r = CzechAddressPlugin.reasoner;
 
             if (r.translate(getSelectedHouse()) != null) {
@@ -347,5 +337,5 @@
 
     private void ensureConsistencyButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_ensureConsistencyButtonActionPerformed
-        CzechAddressPlugin.getReasoner().ensureConsistency();
+        CzechAddressPlugin.reasoner.ensureConsistency();
 }//GEN-LAST:event_ensureConsistencyButtonActionPerformed
 
@@ -405,5 +395,5 @@
             if (boldFont == null) boldFont = getFont().deriveFont(Font.BOLD);
 
-            Reasoner r = CzechAddressPlugin.getReasoner();
+            Reasoner r = CzechAddressPlugin.reasoner;
 
             if (value instanceof House) {
@@ -413,5 +403,5 @@
                 setFont(plainFont);
 
-                if ( r.getConflicts(house) != null)
+                if ( r.conflicts(house) != null)
                     setIcon(envelopeExclIcon);
                 else if ( r.translate(house) == null) {
@@ -457,5 +447,5 @@
 
         public void rebuild() {
-            Reasoner r = CzechAddressPlugin.getReasoner();
+            Reasoner r = CzechAddressPlugin.reasoner;
             if (r == null) return;
 
Index: applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/gui/PointManipulatorDialog.java
===================================================================
--- applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/gui/PointManipulatorDialog.java	(revision 15203)
+++ applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/gui/PointManipulatorDialog.java	(revision 15461)
@@ -368,5 +368,5 @@
                 if (match.elem instanceof House) {
                     setIcon(envelopeStarIcon);
-                    if ( r.getConflicts(match.elem) != null )
+                    if ( r.conflicts(match.elem) != null )
                         setIcon(envelopeExclIcon);
                     else if ( r.translate(match.elem) != null)
Index: applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/gui/Renamer.form
===================================================================
--- applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/gui/Renamer.form	(revision 15461)
+++ applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/gui/Renamer.form	(revision 15461)
@@ -0,0 +1,99 @@
+<?xml version="1.0" encoding="UTF-8" ?>
+
+<Form version="1.5" maxVersion="1.7" type="org.netbeans.modules.form.forminfo.JDialogFormInfo">
+  <Properties>
+    <Property name="defaultCloseOperation" type="int" value="2"/>
+  </Properties>
+  <SyntheticProperties>
+    <SyntheticProperty name="formSizePolicy" type="int" value="1"/>
+  </SyntheticProperties>
+  <AuxValues>
+    <AuxValue name="FormSettings_autoResourcing" type="java.lang.Integer" value="0"/>
+    <AuxValue name="FormSettings_autoSetComponentName" type="java.lang.Boolean" value="false"/>
+    <AuxValue name="FormSettings_generateFQN" type="java.lang.Boolean" value="true"/>
+    <AuxValue name="FormSettings_generateMnemonicsCode" type="java.lang.Boolean" value="false"/>
+    <AuxValue name="FormSettings_i18nAutoMode" type="java.lang.Boolean" value="false"/>
+    <AuxValue name="FormSettings_layoutCodeTarget" type="java.lang.Integer" value="1"/>
+    <AuxValue name="FormSettings_listenerGenerationStyle" type="java.lang.Integer" value="0"/>
+    <AuxValue name="FormSettings_variablesLocal" type="java.lang.Boolean" value="false"/>
+    <AuxValue name="FormSettings_variablesModifier" type="java.lang.Integer" value="2"/>
+    <AuxValue name="designerSize" type="java.awt.Dimension" value="-84,-19,0,5,115,114,0,18,106,97,118,97,46,97,119,116,46,68,105,109,101,110,115,105,111,110,65,-114,-39,-41,-84,95,68,20,2,0,2,73,0,6,104,101,105,103,104,116,73,0,5,119,105,100,116,104,120,112,0,0,1,58,0,0,1,-36"/>
+  </AuxValues>
+
+  <Layout class="org.netbeans.modules.form.compat2.layouts.DesignGridLayout">
+    <Property name="columns" type="int" value="0"/>
+    <Property name="rows" type="int" value="1"/>
+  </Layout>
+  <SubComponents>
+    <Container class="javax.swing.JPanel" name="mainPanel">
+
+      <Layout>
+        <DimensionLayout dim="0">
+          <Group type="103" groupAlignment="0" attributes="0">
+              <Component id="tabbedPane" alignment="0" pref="476" max="32767" attributes="0"/>
+          </Group>
+        </DimensionLayout>
+        <DimensionLayout dim="1">
+          <Group type="103" groupAlignment="0" attributes="0">
+              <Group type="102" alignment="0" attributes="0">
+                  <Component id="tabbedPane" min="-2" pref="289" max="-2" attributes="0"/>
+                  <EmptySpace pref="25" max="32767" attributes="0"/>
+              </Group>
+          </Group>
+        </DimensionLayout>
+      </Layout>
+      <SubComponents>
+        <Container class="javax.swing.JTabbedPane" name="tabbedPane">
+
+          <Layout class="org.netbeans.modules.form.compat2.layouts.support.JTabbedPaneSupportLayout"/>
+          <SubComponents>
+            <Container class="javax.swing.JScrollPane" name="streetScrollPane">
+              <AuxValues>
+                <AuxValue name="autoScrollPane" type="java.lang.Boolean" value="true"/>
+              </AuxValues>
+              <Constraints>
+                <Constraint layoutClass="org.netbeans.modules.form.compat2.layouts.support.JTabbedPaneSupportLayout" value="org.netbeans.modules.form.compat2.layouts.support.JTabbedPaneSupportLayout$JTabbedPaneConstraintsDescription">
+                  <JTabbedPaneConstraints tabName="Ulice">
+                    <Property name="tabTitle" type="java.lang.String" value="Ulice"/>
+                  </JTabbedPaneConstraints>
+                </Constraint>
+              </Constraints>
+
+              <Layout class="org.netbeans.modules.form.compat2.layouts.support.JScrollPaneSupportLayout"/>
+              <SubComponents>
+                <Component class="javax.swing.JTable" name="streetTable">
+                  <Properties>
+                    <Property name="model" type="javax.swing.table.TableModel" editor="org.netbeans.modules.form.editors2.TableModelEditor">
+                      <Table columnCount="2" rowCount="4">
+                        <Column editable="false" title="P&#x16f;vodn&#xed; n&#xe1;zev" type="java.lang.Object"/>
+                        <Column editable="true" title="N&#xe1;vrh z mapy" type="java.lang.String"/>
+                      </Table>
+                    </Property>
+                    <Property name="columnModel" type="javax.swing.table.TableColumnModel" editor="org.netbeans.modules.form.editors2.TableColumnModelEditor">
+                      <TableColumnModel selectionModel="2">
+                        <Column maxWidth="-1" minWidth="-1" prefWidth="-1" resizable="true">
+                          <Title/>
+                          <Editor/>
+                          <Renderer/>
+                        </Column>
+                        <Column maxWidth="-1" minWidth="-1" prefWidth="-1" resizable="false">
+                          <Title/>
+                          <Editor/>
+                          <Renderer/>
+                        </Column>
+                      </TableColumnModel>
+                    </Property>
+                    <Property name="columnSelectionAllowed" type="boolean" value="true"/>
+                    <Property name="tableHeader" type="javax.swing.table.JTableHeader" editor="org.netbeans.modules.form.editors2.JTableHeaderEditor">
+                      <TableHeader reorderingAllowed="true" resizingAllowed="true"/>
+                    </Property>
+                  </Properties>
+                </Component>
+              </SubComponents>
+            </Container>
+          </SubComponents>
+        </Container>
+      </SubComponents>
+    </Container>
+  </SubComponents>
+</Form>
Index: applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/gui/Renamer.java
===================================================================
--- applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/gui/Renamer.java	(revision 15461)
+++ applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/gui/Renamer.java	(revision 15461)
@@ -0,0 +1,222 @@
+/*
+ * To change this template, choose Tools | Templates
+ * and open the template in the editor.
+ */
+
+/*
+ * Renamer.java
+ *
+ * Created on 24.5.2009, 18:03:35
+ */
+
+package org.openstreetmap.josm.plugins.czechaddress.gui;
+
+import java.awt.Component;
+import java.awt.event.ActionEvent;
+import java.util.ArrayList;
+import java.util.List;
+import javax.swing.JTable;
+import javax.swing.event.TableModelListener;
+import javax.swing.table.DefaultTableCellRenderer;
+import javax.swing.table.TableModel;
+import org.openstreetmap.josm.Main;
+import org.openstreetmap.josm.gui.ExtendedDialog;
+import org.openstreetmap.josm.plugins.czechaddress.CzechAddressPlugin;
+import org.openstreetmap.josm.plugins.czechaddress.addressdatabase.AddressElement;
+import org.openstreetmap.josm.plugins.czechaddress.addressdatabase.Street;
+import org.openstreetmap.josm.plugins.czechaddress.intelligence.Capitalizator;
+
+/**
+ *
+ * @author radek
+ */
+public class Renamer extends ExtendedDialog {
+
+    StreetModel<Street> streetModel = new StreetModel<Street>();
+
+    /** Creates new form Renamer */
+    public Renamer() {
+
+        super(Main.parent, "Upravit databázi",
+                                      new String[] { "OK", "Zrušit"}, true);
+        initComponents();
+
+        Capitalizator cap = new Capitalizator(
+                                Main.ds.allPrimitives(),
+                                CzechAddressPlugin.getLocation().getStreets());
+
+        for (Street capStreet : cap.getCapitalised()) {
+            assert cap.translate(capStreet).get("name") != null : capStreet;
+
+            String elemName = capStreet.getName();
+            String primName = cap.translate(capStreet).get("name");
+
+            if (!elemName.equals(primName)) {
+                streetModel.elems.add(capStreet);
+                streetModel.names.add(primName);
+            }
+        }
+
+        streetTable.setModel(streetModel);
+        streetTable.setDefaultRenderer( AddressElement.class,
+                                        new AddressElementRenderer());
+
+        // And finalize initializing the form.
+        setupDialog(mainPanel, new String[] { "ok.png", "cancel.png" });
+    }
+
+    @Override
+    protected void buttonAction(ActionEvent evt) {
+        super.buttonAction(evt);
+
+        if (getValue() == 1) {
+            assert streetModel.elems.size() == streetModel.names.size();
+            
+            for(int i=0; i<streetModel.elems.size(); i++)
+                streetModel.elems.get(i).setName(streetModel.names.get(i));
+        }
+
+        setVisible(false);
+    }
+
+    /** This method is called from within the constructor to
+     * initialize the form.
+     * WARNING: Do NOT modify this code. The content of this method is
+     * always regenerated by the Form Editor.
+     */
+    @SuppressWarnings("unchecked")
+    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
+    private void initComponents() {
+
+        mainPanel = new javax.swing.JPanel();
+        tabbedPane = new javax.swing.JTabbedPane();
+        streetScrollPane = new javax.swing.JScrollPane();
+        streetTable = new javax.swing.JTable();
+
+        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
+        getContentPane().setLayout(new java.awt.GridLayout(1, 0));
+
+        streetTable.setModel(new javax.swing.table.DefaultTableModel(
+            new Object [][] {
+                {null, null},
+                {null, null},
+                {null, null},
+                {null, null}
+            },
+            new String [] {
+                "Původní název", "Návrh z mapy"
+            }
+        ) {
+            Class[] types = new Class [] {
+                java.lang.Object.class, java.lang.String.class
+            };
+            boolean[] canEdit = new boolean [] {
+                false, true
+            };
+
+            public Class getColumnClass(int columnIndex) {
+                return types [columnIndex];
+            }
+
+            public boolean isCellEditable(int rowIndex, int columnIndex) {
+                return canEdit [columnIndex];
+            }
+        });
+        streetTable.setColumnSelectionAllowed(true);
+        streetScrollPane.setViewportView(streetTable);
+        streetTable.getColumnModel().getSelectionModel().setSelectionMode(javax.swing.ListSelectionModel.SINGLE_INTERVAL_SELECTION);
+        streetTable.getColumnModel().getColumn(1).setResizable(false);
+
+        tabbedPane.addTab("Ulice", streetScrollPane);
+
+        javax.swing.GroupLayout mainPanelLayout = new javax.swing.GroupLayout(mainPanel);
+        mainPanel.setLayout(mainPanelLayout);
+        mainPanelLayout.setHorizontalGroup(
+            mainPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
+            .addComponent(tabbedPane, javax.swing.GroupLayout.DEFAULT_SIZE, 476, Short.MAX_VALUE)
+        );
+        mainPanelLayout.setVerticalGroup(
+            mainPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
+            .addGroup(mainPanelLayout.createSequentialGroup()
+                .addComponent(tabbedPane, javax.swing.GroupLayout.PREFERRED_SIZE, 289, javax.swing.GroupLayout.PREFERRED_SIZE)
+                .addContainerGap(25, Short.MAX_VALUE))
+        );
+
+        getContentPane().add(mainPanel);
+
+        pack();
+    }// </editor-fold>//GEN-END:initComponents
+
+    // Variables declaration - do not modify//GEN-BEGIN:variables
+    private javax.swing.JPanel mainPanel;
+    private javax.swing.JScrollPane streetScrollPane;
+    private javax.swing.JTable streetTable;
+    private javax.swing.JTabbedPane tabbedPane;
+    // End of variables declaration//GEN-END:variables
+
+    private class AddressElementRenderer extends DefaultTableCellRenderer {
+
+        public AddressElementRenderer() {}
+
+        @Override
+        protected void setValue(Object value) {
+            super.setValue(value);
+
+            if (value instanceof AddressElement)
+                setText(((AddressElement) value).getName() );
+        }
+    }
+
+    private class StreetModel<Element> implements TableModel {
+
+        List<Element> elems = new ArrayList<Element>();
+        List<String>  names = new ArrayList<String>();
+
+        public int getRowCount() {
+            assert elems.size() == names.size();
+            return elems.size();
+        }
+
+        public int getColumnCount() {
+            return 2;
+        }
+
+        public String getColumnName(int columnIndex) {
+            if (columnIndex == 0) return "Původní název";
+            if (columnIndex == 1) return "Navržený název";
+            assert false : columnIndex;
+            return null;
+        }
+
+        public Class<?> getColumnClass(int columnIndex) {
+            if (columnIndex == 0) return AddressElement.class;
+            if (columnIndex == 1) return String.class;
+            assert false : columnIndex;
+            return null;
+        }
+
+        public boolean isCellEditable(int rowIndex, int columnIndex) {
+            return columnIndex == 1;
+        }
+
+        public Object getValueAt(int rowIndex, int columnIndex) {
+            if (columnIndex == 0) return elems.get(rowIndex);
+            if (columnIndex == 1) return names.get(rowIndex);
+            assert false : columnIndex;
+            return null;
+        }
+
+        public void setValueAt(Object aValue, int rowIndex, int columnIndex) {
+            assert columnIndex == 1;
+            names.set(rowIndex, (String) aValue);
+        }
+
+        public void addTableModelListener(TableModelListener l) {
+            
+        }
+
+        public void removeTableModelListener(TableModelListener l) {
+            
+        }
+    }
+}
Index: applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/gui/UniversalTreeRenderer.java
===================================================================
--- applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/gui/UniversalTreeRenderer.java	(revision 15203)
+++ applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/gui/UniversalTreeRenderer.java	(revision 15461)
@@ -65,9 +65,9 @@
 
 
-        if (value instanceof House) {
+        if (value instanceof House && r != null) {
             House house = (House) value;
 
             setIcon(envelopeNormIcon);
-            if ( r.getConflicts(house) != null )
+            if ( r.conflicts(house) != null )
                 setIcon(envelopeExclIcon);
             else if ( r.translate(house) == null)
Index: applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/intelligence/Match.java
===================================================================
--- applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/intelligence/Match.java	(revision 15203)
+++ applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/intelligence/Match.java	(revision 15461)
@@ -2,5 +2,6 @@
 
 import java.util.List;
-import org.openstreetmap.josm.data.osm.Node;
+import java.util.logging.Level;
+import java.util.logging.Logger;
 import org.openstreetmap.josm.data.osm.OsmPrimitive;
 import org.openstreetmap.josm.plugins.czechaddress.addressdatabase.AddressElement;
@@ -20,9 +21,10 @@
     public static final int MATCH_NOMATCH   = 0;
     
-    public int quality;
+    public int qVal;
     public OsmPrimitive prim;
     public AddressElement elem;
 
     public String checkSum;
+    public static Logger logger = Logger.getLogger("Match");
 
     public Match(AddressElement element, OsmPrimitive primitive,
@@ -30,17 +32,10 @@
         
         assert primitive != null;
-        assert element != null;
-        assert qualityFactor <= MATCH_OVERWRITE;
-        assert qualityFactor > MATCH_NOMATCH
-             : "MATCH_NOMATCH represents no relation."
-             + "It's pointless to waste memory for it.";
-
+        assert element   != null;
         assert !primitive.deleted;
 
         prim = primitive;
         elem = element;
-        quality = qualityFactor;
-
-        checkSum = toString();
+        qVal = qualityFactor;
     }
 
@@ -53,4 +48,8 @@
 
         int quality = element.getMatchQuality(primitive);
+
+        logger.log(Level.FINE, "asked to create match",
+                               new Object[] {element, primitive, quality});
+
         if (quality > MATCH_NOMATCH)
             return new Match(element, primitive, quality);
@@ -58,28 +57,30 @@
         return null;
     }
+/*
+    public boolean setQ(int desiredQ) {
+        int oldQ = evalQ();
+        qVal = desiredQ;
+        int newQ = evalQ();
 
-    public boolean qualityChanged() {
-        int newQuality
-        = prim.deleted ? MATCH_NOMATCH
-                       : quality == MATCH_OVERWRITE ? MATCH_OVERWRITE
-                                                    : elem.getMatchQuality(prim);
-        if (prim instanceof Node) {
-            Node node = (Node) prim;
-            if (node.coor == null || node.eastNorth == null) {
-                newQuality = MATCH_NOMATCH;
-                System.out.println("Suspicious node, ignoring it: " + AddressElement.getName(node));
-            }
-        }
-            
+        if (oldQ != newQ)
+            logger.log(Level.INFO, "changing match value: " + oldQ + " --> " + newQ
+                                 + " (desired value is " + desiredQ + ")", this);
+        return oldQ != evalQ();
+    }
+*/
+    public static int evalQ(OsmPrimitive prim, AddressElement elem, Integer oldQ) {
         
-        boolean difference = newQuality != quality;
-        quality = newQuality;
+        if (prim.deleted)
+            return MATCH_NOMATCH;
 
-        return difference;
+        if (oldQ == MATCH_OVERWRITE)
+            return MATCH_OVERWRITE;
+
+        return elem.getMatchQuality(prim);
     }
 
     @Override
     public String toString() {
-        return "{Match: q=" + String.valueOf(quality)
+        return "{Match: q=" + String.valueOf(qVal)
                    + "; elem='" + elem.toString()
                    +"'; prim='" + AddressElement.getName(prim) + "'}";
Index: applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/intelligence/Reasoner.java
===================================================================
--- applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/intelligence/Reasoner.java	(revision 15203)
+++ applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/intelligence/Reasoner.java	(revision 15461)
@@ -1,16 +1,17 @@
 package org.openstreetmap.josm.plugins.czechaddress.intelligence;
 
-import java.util.ArrayList;
-import java.util.Collection;
 import java.util.HashMap;
-import java.util.List;
+import java.util.HashSet;
+import java.util.Map;
+import java.util.Set;
+import java.util.logging.FileHandler;
+import java.util.logging.Handler;
+import java.util.logging.Level;
+import java.util.logging.Logger;
+import org.openstreetmap.josm.data.osm.Node;
 import org.openstreetmap.josm.data.osm.OsmPrimitive;
-import org.openstreetmap.josm.plugins.czechaddress.CzechAddressPlugin;
-import org.openstreetmap.josm.plugins.czechaddress.NotNullList;
-import org.openstreetmap.josm.plugins.czechaddress.StatusListener;
 import org.openstreetmap.josm.plugins.czechaddress.addressdatabase.AddressElement;
 import org.openstreetmap.josm.plugins.czechaddress.addressdatabase.House;
-import org.openstreetmap.josm.plugins.czechaddress.proposal.ProposalContainer;
-import org.openstreetmap.josm.plugins.czechaddress.proposal.ProposalDatabase;
+import org.openstreetmap.josm.plugins.czechaddress.addressdatabase.Street;
 
 /**
